#ifndef _sql_h_
#define _sql_h_

#include <tds.h>

#ifdef __cplusplus
extern "C" {
#endif

static char  rcsid_sql_h [ ] =
         "$Id: sql.h,v 1.5 1998/12/20 02:20:20 camber Exp $";
static void *no_unused_sql_h_warn[]={rcsid_sql_h, no_unused_sql_h_warn};


#define SQL_NULL_HENV       NULL
#define SQL_NULL_HDBC       NULL
#define SQL_NULL_HSTMT      NULL
/* these are just sequential as I run into them...I suppose we need to find an unencumbered sql.h eventually...this should work for now */
#define SQL_NTS             1
#define SQL_ACCESS_MODE     4
#define SQL_MODE_READ_ONLY  5
#define SQL_AUTOCOMMIT      6
#define SQL_AUTOCOMMIT_ON   7
#define SQL_PARAM_INPUT     8
#define SQL_C_SLONG         9
#define SQL_INTEGER        10
#define SQL_CHAR           11
#define SQL_C_INT          12

/* return codes */
#define SQL_NO_DATA          -1
#define SQL_FAILURE           0
#define SQL_SUCCESS           1
#define SQL_SUCCESS_WITH_INFO 2

/* probably */
#define SQL_NULL_DATA       -1    

#define SQL_MAX_MESSAGE_LENGTH      256

typedef TDS_SMALLINT SQLSMALLINT;
typedef TDS_SMALLINT SQLUSMALLINT;
typedef TDS_INT      SQLINTEGER;
typedef TDS_UINT     SQLUINTEGER;
typedef unsigned TDS_CHAR     SQLCHAR; 
typedef void *       SQLPOINTER;

typedef struct {
	int dummy;
} DATE_STRUCT;
struct _henv {
	int dummy;
};
typedef struct _henv *SQLHENV;
typedef struct _henv *HENV;
struct _hdbc {
	SQLHENV henv;
	void *tds_login;
	void *tds_socket;
};
typedef struct _hdbc *SQLHDBC;
typedef struct _hdbc *HDBC;
struct _hstmt {
	SQLHDBC	hdbc;
	/* reminder to self: the following is here for testing purposes.
	 * please make dynamic before checking in 
	 */
	char query[4096];
	struct _sql_bind_info *bind_head;
};
typedef struct _hstmt *SQLHSTMT;
typedef struct _hstmt *HSTMT;

struct _sql_bind_info {
	int column_number;
	int column_bindtype;
	int column_bindlen;
	char *varaddr;
	struct _sql_bind_info *next;
};

typedef int SQLRETURN;
typedef int RETCODE;

/* some windows crap for portability...move to window.h maybe? */
typedef unsigned char UCHAR;
typedef TDS_INT       SDWORD;
typedef TDS_SMALLINT  SWORD;

/* protos */
RETCODE SQLGetTypeInfo(SQLHSTMT hstmt, SQLSMALLINT sql_type);
RETCODE SQLAllocEnv(SQLHENV *penv);
RETCODE SQLAllocConnect(SQLHENV env, SQLHDBC *phdbc);
RETCODE SQLConnect(SQLHDBC hdbc, SQLCHAR *svr_name, SQLSMALLINT svr_name_len, 
	SQLCHAR *user_name, SQLSMALLINT user_name_len,
	SQLCHAR *password, SQLSMALLINT password_len);
RETCODE SQLError(SQLHENV henv, SQLHDBC hdbc, SQLHSTMT hstmt, 
	SQLCHAR *szSqlState, SQLINTEGER *pfNativeError, SQLCHAR *szErrorMsg, 
	SQLSMALLINT cbErrorMsgMax, SQLSMALLINT *pcbErrorMsg);
RETCODE SQLSetConnectOption(SQLHDBC hdbc, int, int);
RETCODE SQLAllocStmt(SQLHDBC hdbc, SQLHSTMT *phstmt);
RETCODE SQLPrepare(SQLHSTMT hstmt, SQLCHAR *stmt_text, SQLINTEGER test_len);
RETCODE SQLBindParameter(SQLHSTMT hstmt, SQLUSMALLINT param_num, 
	SQLSMALLINT in_out_type, SQLSMALLINT value_type, 
	SQLSMALLINT param_type, SQLUINTEGER column_size,
	SQLSMALLINT decimal_digits, SQLPOINTER pparam_value,
	SQLINTEGER buffer_len, SQLINTEGER *pstr_len); 
RETCODE SQLExecute(SQLHSTMT hstmt);
RETCODE SQLFetch(SQLHSTMT hstmt);
RETCODE SQLCloseCursor(SQLHSTMT hstmt);

#ifdef __cplusplus
}
#endif

#endif
