#include <stdio.h>
#include <tds.h>


static char  software_version[]   = "$Id: tdstest.c,v 1.3 1998/11/20 21:22:13 cts Exp $";
static void *no_unused_var_warn[] = {software_version,
                                     no_unused_var_warn};


char *value_as_string(
   TDSSOCKET  *tds,
   int         col_idx)
{
   static char  result[256]; 
   const int    type    = tds->res_info->columns[col_idx]->column_type;
   const char  *row     = tds->res_info->current_row;
   const int    offset  = tds->res_info->columns[col_idx]->column_offset;
   const void  *value   = (row+offset);

   switch(type)
   {
      case SYBVARCHAR:
      {
         strncpy(result, (char *)value, sizeof(result)-1);
         result[sizeof(result)-1] = '\0';
         break;
      }
      case SYBINT4:
      {
         sprintf(result, "%d", *(int *)value);
         break;
      }
      default:
      {
         strcpy(result, "NotImp");
         break;
      }
   }
   return result;
} /* value_as_string()  */


int main()
{
TDSLOGIN *login;
TDSSOCKET *tds;
int rc;
int i;

 login = tds_alloc_login();
 tds_set_passwd(login,"sybase");
 tds_set_user(login,"guest");
 tds_set_app(login,"sqsh");
 tds_set_host(login,"myhost");
 tds_set_library(login,"TDS-Library");
 tds_set_server(login,"JDBC");
 tds_set_charset(login,"iso_1");
 tds_set_language(login,"us_english");
 tds_set_packet(login,512);

 if (!(tds = tds_connect(login))) {
	fprintf(stderr, "Login Failed!\n");
	exit(1);
 }

 /* tds_submit_query(tds,"select db_name() dbname, user_name() username"); */
 /* tds_submit_query(tds,"select idx from groups"); */
 tds_submit_query(tds,"select name, id from sysobjects"); 
 while ((rc=tds_process_result_tokens(tds))==TDS_SUCCEED) 
 {
    for (i=0; i<tds->res_info->num_cols; i++)
    {
       printf("col %d\n  Type:   %d\n  Name:   %s\n  Offset: %d\n", 
              i, 
              tds->res_info->columns[i]->column_type, 
              tds->res_info->columns[i]->column_name,
              tds->res_info->columns[i]->column_offset);
    }
    
    while ((rc=tds_process_row_tokens(tds))==TDS_SUCCEED) 
    {
       for (i=0; i<tds->res_info->num_cols; i++)
       {
          printf("col %i is %s\n", i, value_as_string(tds, i));
       }
    }
 }
 return 0;
}
