#include <tds.h>

static char  software_version[]   = "$Id: server.c,v 1.5 1998/11/28 04:55:04 camber Exp $";
static void *no_unused_var_warn[] = {software_version,
                                     no_unused_var_warn};


tds_env_change(TDSSOCKET *tds,int type, char *oldvalue, char *newvalue)
{
TDS_SMALLINT totsize;

	tds_put_byte(tds,TDS_ENV_CHG_TOKEN);
	switch(type) {
		case 1:
			/* totsize = type + newlen + newvalue + oldlen + oldvalue  */
			totsize = strlen(oldvalue) + strlen(newvalue) + 3;
			tds_put_smallint(tds, totsize);
			tds_put_byte(tds,type);
			tds_put_byte(tds,strlen(newvalue));
			tds_put_n(tds,newvalue,strlen(newvalue));
			tds_put_byte(tds,strlen(oldvalue));
			tds_put_n(tds,oldvalue,strlen(oldvalue));
			break;
		case 2:
			/* totsize = type + len + string + \0 */
			totsize = strlen(newvalue) + 3;
			tds_put_smallint(tds, totsize);
			tds_put_byte(tds,type);
			tds_put_byte(tds,strlen(newvalue));
			tds_put_n(tds,newvalue,strlen(newvalue));
			tds_put_byte(tds,'\0');
			break;
		case 4:
			/* totsize = type + len + string + \0 */
			totsize = strlen(newvalue) + 3;
			tds_put_smallint(tds, totsize);
			tds_put_byte(tds,type);
			tds_put_byte(tds,strlen(newvalue));
			tds_put_n(tds,newvalue,strlen(newvalue));
			tds_put_byte(tds,'\0');
			break;
	}
}

void tds_send_msg(TDSSOCKET *tds,int msgno, int msgstate, int severity,
	char *msgtext, char *srvname, char *procname, int line)
{
int totsize;

	if IS_TDS42(tds) {
		tds_put_byte(tds,TDS_MSG_TOKEN);
	} else {
		tds_put_byte(tds,TDS_MSG50_TOKEN);
		totsize = 7 + strlen(procname) + 5 + strlen(msgtext) + 2 + strlen(srvname) + 3;
		tds_put_smallint(tds,totsize);
		tds_put_smallint(tds,msgno);
		tds_put_smallint(tds,0); /* unknown */
		tds_put_byte(tds, msgstate);
		tds_put_byte(tds, severity);
		tds_put_byte(tds,strlen(procname));
		tds_put_n(tds,procname,strlen(procname));
		tds_put_byte(tds,0); /* unknown */
		tds_put_byte(tds,1); /* unknown */
		tds_put_byte(tds,0); /* unknown */
		tds_put_smallint(tds,strlen(msgtext)+1);
		tds_put_n(tds,msgtext,strlen(msgtext));
		tds_put_byte(tds, severity);
		tds_put_byte(tds,strlen(srvname));
		tds_put_n(tds,srvname,strlen(srvname));
		tds_put_byte(tds,0); /* unknown */
		tds_put_byte(tds,1); /* unknown */
		tds_put_byte(tds,0); /* unknown */
	}
}
void tds_send_err(TDSSOCKET *tds,int severity, int dberr, int oserr, char *dberrstr, char *oserrstr)
{
}
void tds_send_login_ack(TDSSOCKET *tds, char *progname)
{
	tds_put_byte(tds,TDS_LOGIN_ACK_TOKEN);
	tds_put_smallint(tds,10+strlen(progname)); /* length of message */
	if IS_TDS42(tds) {
		tds_put_byte(tds,1);
		tds_put_byte(tds,4);
		tds_put_byte(tds,2);
	} else {
		tds_put_byte(tds,5);
		tds_put_byte(tds,5);
		tds_put_byte(tds,0);
	}
	tds_put_byte(tds,0); /* unknown */
	tds_put_byte(tds,0); /* unknown */
	tds_put_byte(tds,strlen(progname)); 
	tds_put_n(tds,progname,strlen(progname)); 
	tds_put_byte(tds,1); /* unknown */
	tds_put_byte(tds,0); /* unknown */
	tds_put_byte(tds,0); /* unknown */
	tds_put_byte(tds,1); /* unknown */
}
tds_send_226_token(TDSSOCKET *tds)
{
	tds_put_byte(tds,226);
	tds_put_byte(tds,18);
	tds_put_byte(tds,0);
	tds_put_byte(tds,1);
	tds_put_byte(tds,7);
	tds_put_byte(tds,3);
	tds_put_byte(tds,97);
	tds_put_byte(tds,65);
	tds_put_byte(tds,207);
	tds_put_byte(tds,255);
	tds_put_byte(tds,255);
	tds_put_byte(tds,230);
	tds_put_byte(tds,2);
	tds_put_byte(tds,7);
	tds_put_byte(tds,0);
	tds_put_byte(tds,0);
	tds_put_byte(tds,2);
	tds_put_byte(tds,0);
	tds_put_byte(tds,0);
	tds_put_byte(tds,0);
	tds_put_byte(tds,0);
}
tds_send_253_token(TDSSOCKET *tds, TDS_TINYINT flags, TDS_INT numrows)
{
	tds_put_byte(tds,253);
	tds_put_byte(tds,flags);
	tds_put_byte(tds,0);
	tds_put_byte(tds,2);
	tds_put_byte(tds,0);
	tds_put_int(tds,numrows);
}
tds_send_174_token(TDSSOCKET *tds, TDS_SMALLINT numcols)
{
int i;

	tds_put_byte(tds,174);
	tds_put_smallint(tds,numcols);
	for (i=0;i<numcols;i++) {
		tds_put_byte(tds,0);
	}
}
tds_send_result(TDSSOCKET *tds, TDSRESULTINFO *resinfo)
{
TDSCOLINFO *curcol;
int i, totlen;

	tds_put_byte(tds,TDS_RESULT_TOKEN);
	totlen = 2;
	for (i=0;i<resinfo->num_cols;i++) {
		curcol = resinfo->columns[i];
		totlen += 8;
		totlen += strlen(curcol->column_name);
		curcol = resinfo->columns[i];
		if (!is_fixed_type(curcol->column_type)) {
			totlen++;
		}
	}
	tds_put_smallint(tds,totlen);
	tds_put_smallint(tds,resinfo->num_cols);
	for (i=0;i<resinfo->num_cols;i++) {
		curcol = resinfo->columns[i];
		tds_put_byte(tds,strlen(curcol->column_name));
		tds_put_n(tds,curcol->column_name,strlen(curcol->column_name));
		tds_put_byte(tds,'0');
		tds_put_smallint(tds, curcol->column_usertype);
		tds_put_smallint(tds,0);
		tds_put_byte(tds, curcol->column_type);
		if (!is_fixed_type(curcol->column_type)) {
			tds_put_byte(tds, curcol->column_size);
		}
		tds_put_byte(tds,0);
	}
}
tds_send_row(TDSSOCKET *tds, TDSRESULTINFO *resinfo)
{
TDSCOLINFO *curcol;
int colsize, i;

	tds_put_byte(tds,TDS_ROW_TOKEN);
	for (i=0;i<resinfo->num_cols;i++) {
		curcol = resinfo->columns[i];
		if (!is_fixed_type(curcol->column_type)) {
			/* FIX ME -- I have no way of knowing the actual length of non character variable data (eg nullable int) */
			colsize = strlen(&(resinfo->current_row[curcol->column_offset]));
			tds_put_byte(tds, colsize);
			tds_put_n(tds,&(resinfo->current_row[curcol->column_offset]), colsize);
		} else {
			tds_put_n(tds,&(resinfo->current_row[curcol->column_offset]), get_size_by_type(curcol->column_type));
		}
	}
}
